Subject: Re: Workflow example for remote repository use of GIT

From: Jakub Narebski <[email-masked]>
Date: Tue, 28 Nov 2006 17:18:09 +0100

Sean Kelley wrote:

> I have been trying to set-up a workflow for developers in my group
> using GIT. I came up with this simplified flow.  Do you all see any
> problems with this approach?
> 
> Thanks,
> 
> Sean
> 
> 
> 
> Always work out of master
> 
>   git checkout master

This conflicts a bit with later "Create a topic branch" statement.
The statement should be I think twofold: "Never work out of tracking
branches" (if you use separate remotes, git takes care of that for
yourself), and for typical workflow "Always work out of master
or merge changes into master".
 
This of course deopends on the structure of your repo. For example,
how many development branches are there. Git repository uses four
development branches: 'maint' (maintenance, stable, bugfixes),
'master' (trunk, main development, stable), 'next' (development)
and 'pu' (proposed updates, a kind of topic branch digest).

> Getting The Latest Upstream Code into master
> 
>   git pull origin master

It always is "merge into current branch".

Please read what this mean in git-pull(1):

    ?  A parameter <ref> without a colon is equivalent  to  <ref>:  when
       pulling/fetching,  so  it  merges  <ref>  into the current branch
       without storing the remote branch anywhere locally.

So what "git pull origin master" do is to fetch _single_ remote branch
'master' from remote (repository) 'origin' _without_ storing it anywhere
locally (with separate remotes it would be 'remotes/origin/master',
without separate remotes it would be 'origin'), and merge it into _current_
branch.

What you usually want to do, when you are on branch "master", is

  git pull origin

or even

  git pull

> Create a topic branch for your development work
> 
>   git checkout -b <new topic branch name>

One might want to create topic branch off other commit than HEAD,
using

  git checkout -b <new topic branch name> <branch point>

> Do your development in the topic branch
> 
>   edit/debug/test
> 
> Committing Changes
> 
>   git commit -a

Depending on your project policy, it might be "git commit -a -s",
i.e. add signoff line.

> Switch back to master
> 
>   git checkout master
> 
> Update the master branch from origin again
> 
>   git pull origin master

The same comment as above.

By the way, this is _not_ CVS, you can merge your topic branch first,
_then_ pull from origin.

> Now Merge your topic branch
> 
>   git pull . <topic branch to merge into current branch>

I'd point out that '.' means current repository here.

> How do I push my changes to the original repository?
> 
>   git push origin master

Probably (and better) just "git push origin" if everything is set up
correctly.

-- 
Jakub Narebski
Warsaw, Poland
ShadeHawk on #git